EDIT - feature request #7680

Refactor TaxonNodeDetailElement
08/24/2018 10:27 AM - Patrick Plitzner

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.5

Severity: normal

Description

Copied from #7679:

While investigating this issue | realized that the NewTaxonNodeWizard does not work like all the other "new" wizards.
Usually the sequence is as follows:

1.In AbstractNewEntityWizard.createNewEntity() a new instance of the class is created.

protected Reference createNewEntity () {
return ReferenceFactory.newGeneric();

}

2.The wizard page returns a detail element for the newly created entity via AbstractCdmEntityWizardPage.getDetailElement()
This is the same element as used in the DetailsView.
3.The handleEvent() method listens to editing changes in the detail element and stores the parameters to the newly created entity

public void handleEvent (Object eventSource) {
if (eventSource == combo_referenceType) {
getEntity () .setType (combo_referenceType.getSelection());

4 When closing the wizard AbstractNewEntityWizard.saveEntity() is invoked

protected void saveEntity () {
CdmStore.getService (IReferenceService.class) .save (getEntity ());

}

e The new taxon node wizard does not create a new entity but uses the current selection.

¢ This is why all these exception are thrown when creating a root child because the entity used in the wizard is the classification
and not the new taxon node as it should be.

¢ Only during saveEntity() a new taxon instance is created (should be done createNewEntity()) and all the Ul parameter fields
are stored to the taxon (should be done in handleEvent())

Related issues:
Related to EDIT - bug #7689: Mutliple representation exception when creating ... Worksforme
Copied from EDIT - bug #7679: NPE when creating root child in classification Closed

Associated revisions

Revision e04a2b79 - 08/28/2018 01:33 PM - Katja Luther

ref #7680: unplaced, excluded and publish checkboxes should be available in NewTaxonnodeWizard

Revision 9da648a0 - 08/28/2018 01:38 PM - Katja Luther
ref #7680: fix NPE for excluded notes

Revision 4443b90a - 10/11/2018 01:31 PM - Katja Luther

ref #7793: adapt taxonnode wizard and add menu item to set unplaced in navigator

Revision 83f2186a - 10/11/2018 02:01 PM - Katja Luther

ref #7793: adapt taxonnode wizard and add menu item to set excluded in navigator

03/13/2024 1/3



https://dev.e-taxonomy.eu/redmine/issues/7679

Revision 05a6f11d - 10/12/2018 10:16 AM - Katja Luther

ref #7793: add preference for show taxonnode wizard

Revision c6aeda45 - 01/25/2019 11:33 AM - Katja Luther

ref #7680: set TaxonNode.setTaxon public and new saveMethod for taxonnodes

Revision e4a9f18a - 01/25/2019 11:36 AM - Katja Luther
ref #7680: refactor NewTaxonNodeWizard like other NewEntityWizards

Revision 326dab64 - 01/31/2019 05:04 PM - Katja Luther

ref #7680: code cleaning remove unnecessary code

History

#1 - 08/24/2018 10:27 AM - Patrick Plitzner
- Description updated

#2 - 08/24/2018 10:28 AM - Patrick Plitzner
- Copied from bug #7679: NPE when creating root child in classification added

#3 - 08/27/2018 12:01 PM - Katja Luther
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 5.3

#4 - 08/28/2018 01:30 PM - Katja Luther

- Status changed from New to In Progress

the problems of not visible unplaced, excluded and publish checkboxes are fixed now. But to implement the NewTaxonNodeWizard the same way as
the other NewWizards we need to add the possibility to create a taxonNode or to change the taxon of a taxonNode. Maybe we should discuss this
before we implement these options.

#5 - 09/06/2018 01:19 PM - Katja Luther

- Target version changed from Release 5.3 to Release 5.4

the functionality is available now, but as described in the comment above we would need the functionality to create a TaxonNode without a taxon to
use the newWizard the same as the other newWizards. Therefore | move this ticket to next release.

#6 - 10/23/2018 11:18 AM - Andreas Miiller
- Target version changed from Release 5.4 to Release 5.5

- % Done changed from 0 to 20

some work has been done within #7793, | added the commits to this ticket.

However, due to the described problem a complete refactoring of the taxon node wizard is not yet done so | move ticket to next milestone

#7 - 01/25/2019 11:56 AM - Katja Luther
- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

now the newTaxonNodeWizard works like the other newEntityWizards and the taxonnode is created when the wizard opens and the changes are
made directly in this new entity.

#8 - 01/27/2019 09:00 AM - Andreas Miiller
- Assignee changed from Andreas Miiller to Patrick Plitzner

- % Done changed from 20 to 50

As PP opened this ticket and as it is mostly about code design | think it is better if he reviews this ticket.

How did you solve the problem that TaxonNodes can not be instantiate (yet)?
#9 - 01/30/2019 09:37 AM - Patrick Plitzner
- Status changed from Resolved to Feedback

- Assignee changed from Patrick Plitzner to Katja Luther

I have not stepped through all lines of code but still the saveEntity() method seems to do too much. A new taxon is created and Ul properties are
assigned to CDM entities. In almost all other wizards the method is a one-liner like in the example in the ticket description.

The wizard itself works nonetheless except for some smalles issues -> #8036, #8037
#10 - 01/31/2019 05:05 PM - Katja Luther

- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Patrick Plitzner

Patrick Plitzner wrote:

| have not stepped through all lines of code but still the saveEntity() method seems to do too much. A new taxon is created and Ul properties
are assigned to CDM entities. In almost all other wizards the method is a one-liner like in the example in the ticket description.

The wizard itself works nonetheless except for some smalles issues -> #8036, #8037

code is cleaned and unnecessary code removed

#11 - 02/01/2019 10:29 AM - Patrick Plitzner
- Status changed from Resolved to Closed
- Assignee changed from Patrick Plitzner to Katja Luther

- % Done changed from 50 to 100

Looks much better now. There is still happening a lot compared to the other "New-"wizards but a taxon node is a highly linked structure.

#12 - 02/22/2019 10:01 AM - Katja Luther

- Related to bug #7689: Mutliple representation exception when creating taxon nodes added
